﻿Option Explicit On
Imports System
Imports System.IO
Imports System.Text
Imports System.Runtime.InteropServices


Module Module1


    Public Declare Function DemoContourDelete Lib "DemoContour64" () As Integer
    Public Declare Function DemoContourCreate Lib "DemoContour64" () As Integer

    Public Declare Function DemoContourCalculateIsolines Lib "DemoContour64" (ByVal i As Integer, ByVal aLevels As IntPtr) As Integer
    Public Declare Function DemoContourSetGrid Lib "DemoContour64" (ByVal nX As Integer, ByVal nY As Integer, ByVal aXptr As IntPtr, ByVal aYptr As IntPtr, ByVal aVptr As IntPtr) As Integer
    Public Declare Function DemoContourSetGridEx Lib "DemoContour64" (ByVal nX As Integer, ByVal nY As Integer, ByVal aXptr As IntPtr, ByVal aYptr As IntPtr, ByVal aVptr As IntPtr, ByVal aTptr As IntPtr) As Integer
    Public Declare Function DemoContourIsolinesCount Lib "DemoContour64" () As Integer
    Public Declare Function DemoContourLinesCount Lib "DemoContour64" (ByVal nL As Integer) As Integer
    Public Declare Function DemoContourPointsCount Lib "DemoContour64" (ByVal nL As Integer, ByVal nL As Integer) As Integer
    Public Declare Function DemoContourGetPoint Lib "DemoContour64" (ByVal nL As Integer, ByVal nL As Integer, ByVal nL As Integer, ByVal d As Double, ByVal a As Double) As Integer
    Public Declare Function DemoContourGridGetMinMax Lib "DemoContour64" (ByRef dMin As Double, ByRef dMax As Double) As Integer
    Public Declare Function DemoContourGetIsolinePoints Lib "DemoContour64" (ByVal nIsoloine As Integer, ByVal nLine As Integer, ByVal dCoordX As IntPtr, ByVal dCoordY As IntPtr) As Integer

    Public Declare Function DemoContourCanvasSetHDC Lib "DemoContour64" (ByVal hDC As Integer) As Integer
    Public Declare Function DemoContourCanvasSetLimits Lib "DemoContour64" (ByVal dXMin As Double, ByVal dYMin As Double, ByVal dXMax As Double, ByVal dYMax As Double) As Integer
    Public Declare Function DemoContourCanvasSetLabelValue Lib "DemoContour64" (ByVal dValue As Double) As Integer
    Public Declare Function DemoContourCanvasDrawContour Lib "DemoContour64" (ByVal nCount As Integer, ByVal dCoordX As IntPtr, ByVal dCoordY As IntPtr) As Integer
    Public Declare Function DemoContourCanvasSetSize Lib "DemoContour64" (ByVal nWidth As Integer, ByVal nHeight As Integer) As Integer
    Public Declare Function DemoContourCanvasSetFontHeight Lib "DemoContour64" (ByVal nHeight As Integer) As Integer
    Public Declare Function DemoContourCanvasSetFontFaceName Lib "DemoContour64" (ByVal sName As String) As Integer
    Public Declare Function DemoContourCanvasSetXYRate Lib "DemoContour64" (ByVal nXYRate As Integer) As Integer
    Public Declare Function DemoContourCanvasCoordinateX Lib "DemoContour64" (ByVal lPixelX As Integer) As Double
    Public Declare Function DemoContourCanvasCoordinateY Lib "DemoContour64" (ByVal lPixelY As Integer) As Double
    Public Declare Function DemoContourCanvasPixelX Lib "DemoContour64" (ByVal dX As Double) As Integer
    Public Declare Function DemoContourCanvasPixelY Lib "DemoContour64" (ByVal dY As Double) As Integer
    Public Declare Function DemoContourLabelSetTransparent Lib "DemoContour64" (ByVal nCode As Integer) As Integer

    Public Declare Function DemoContourAxisAdd Lib "DemoContour64" (ByVal sAxeType As String) As Integer
    Public Declare Function DemoContourAxisDraw Lib "DemoContour64" () As Integer
    Public Declare Function DemoContourAxisSetTitle Lib "DemoContour64" (ByVal nAxe As Integer, ByVal sAxeType As String) As Integer
    Public Declare Function DemoContourAxisSetFontFaceName Lib "DemoContour64" (ByVal nAxe As Integer, ByVal sFontName As String) As Integer
    Public Declare Function DemoContourAxisSetFontHeight Lib "DemoContour64" (ByVal nAxe As Integer, ByVal nFontHeight As Integer) As Integer
    Public Declare Function DemoContourAxisSetLongTick Lib "DemoContour64" (ByVal nAxe As Integer, ByVal nYes As Integer) As Integer
    Public Declare Function DemoContourAxisSetAutoTicks Lib "DemoContour64" (ByVal nAxe As Integer, ByVal nYes As Integer) As Integer
    Public Declare Function DemoContourAxisSetTicks Lib "DemoContour64" (ByVal nAxe As Integer, ByVal dFirst As Double, ByVal dStep As Double, ByVal nCount As Integer) As Integer
    Public Declare Function DemoContourAxisSetAutoDecimalPlace Lib "DemoContour64" (ByVal nAxe As Integer, ByVal nYes As Integer) As Integer
    Public Declare Function DemoContourAxisSetDecimalPlace Lib "DemoContour64" (ByVal nAxe As Integer, ByVal nPlace As Integer) As Integer
    Public Declare Function DemoContourAxisCalculate Lib "DemoContour64" () As Integer
    Public Declare Function DemoContourAxisSimpleDraw Lib "DemoContour64" () As Integer

    Dim CONTOUR_RC_OK As Integer
    Dim CONTOUR_RC_ERROR As Integer
    Dim CONTOUR_RC_NO_MEMORY As Integer
    Dim CONTOUR_RC_EXIST As Integer
    Dim CONTOUR_RC_NO_EXIST As Integer

    Dim GlnPoints As Integer
    Dim GldLineCoordX(0 To 500000) As Double
    Dim GldLineCoordY(0 To 500000) As Double

    ' The grid coordinates
    Public GldColumnCoord(0 To 1500) As Double
    Public GldRowCoord(0 To 1500) As Double

    ' Count of rows and colums of grid
    Public GlnRowCount As Integer
    Public GlnColumnCount As Integer

    ' Values of grid
    Public GlardV(0 To 1000000) As Double

    ' Values of contours
    Public GdaContourValues(0 To 100) As Double

    Sub Init()
        Dim nRC As Integer

        Dim CONTOUR_RC_OK As Integer
        Dim CONTOUR_RC_ERROR As Integer
        Dim CONTOUR_RC_NO_MEMORY As Integer
        Dim CONTOUR_RC_EXIST As Integer
        Dim CONTOUR_RC_NO_EXIST As Integer

        ' Return codes for CONTOUR
        CONTOUR_RC_OK = 0
        CONTOUR_RC_ERROR = -1
        CONTOUR_RC_NO_MEMORY = -2
        CONTOUR_RC_EXIST = 1
        CONTOUR_RC_NO_EXIST = 2

        On Error GoTo MetkaErrorContourCreate
        ' Create Contour object
        nRC = DemoContourCreate()
        If nRC <> CONTOUR_RC_OK Then
            If nRC = CONTOUR_RC_EXIST Then
                Debug.Print("Object Contour exist")
            End If
            If nRC = CONTOUR_RC_ERROR Then
                MsgBox("Can't create object Contour")
                Exit Sub
            End If
        End If

        Exit Sub


MetkaErrorContourCreate:
        MsgBox("Function ContourCreate is missing")
        Exit Sub

    End Sub

    Sub FClose()
        Dim nRC As Integer

        nRC = DemoContourDelete()

        Exit Sub

    End Sub


    Sub CreateContours()
        Dim dMin As Double
        Dim dMax As Double
        Dim nRC As Integer
        Dim d As Double
        Dim nCount As Integer
        Dim nLines As Integer
        Dim nI As Integer
        Dim nJ As Integer
        Dim nK As Integer
        Dim dCoeffX As Double
        Dim dCoeffY As Double
        Dim dX1 As Double
        Dim dY1 As Double
        Dim dX2 As Double
        Dim dY2 As Double
        Dim sFile As String
        Dim longWidth As Integer
        Dim longHeight As Integer
        Dim sFont As String
        Dim lPixelX As Integer
        Dim lPixelY As Integer
        Dim dWidth As Double
        Dim dHeight As Double

        Dim dXMin As Double
        Dim dXMax As Double
        Dim dYMin As Double
        Dim dYMax As Double

        Dim dXStep As Double
        Dim dYStep As Double

        ' Return codes for CONTOUR
        CONTOUR_RC_OK = 0
        CONTOUR_RC_ERROR = -1
        CONTOUR_RC_NO_MEMORY = -2
        CONTOUR_RC_EXIST = 1
        CONTOUR_RC_NO_EXIST = 2

        dWidth = Form1.PictureBox1.Width()
        dHeight = Form1.PictureBox1.Height()


        On Error GoTo MetkaNoFile
        sFile = "Matrix.txt"

        Dim charSeparators() As Char = {" "c}

        Dim fs As StreamReader = File.OpenText(sFile)

        Dim input As String
        input = fs.ReadLine()
        Dim split() As String
        split = input.Split(charSeparators, 2, StringSplitOptions.RemoveEmptyEntries)

        GlnColumnCount = Convert.ToInt32(split(0))
        GlnRowCount = Convert.ToInt32(split(1))

        For nJ = 0 To GlnRowCount - 1
            For nI = 0 To GlnColumnCount - 1
                input = fs.ReadLine()
                GlardV(nJ * GlnColumnCount + nI) = Convert.ToDouble(input)
            Next nI
        Next nJ

        fs.Close()

        If GlnRowCount > 50 Or GlnColumnCount > 50 Then
            MsgBox("Sorry. It is demo. Grid size no more 50x50")
            Exit Sub
        End If

        '   Size of demo map is (1,1)
        dXMin = 0
        dXMax = 1
        dYMin = 0
        dYMax = 1

        '   Calculate the steps of grid
        dXStep = (dXMax - dXMin) / (GlnColumnCount - 1)
        dYStep = (dYMax - dYMin) / (GlnRowCount - 1)

        '   Calculate the coordinates of grid
        GldColumnCoord(0) = dXMin
        For nJ = 1 To GlnColumnCount - 1
            GldColumnCoord(nJ) = GldColumnCoord(nJ - 1) + dXStep
        Next nJ

        GldRowCoord(0) = dYMin
        For nJ = 1 To GlnRowCount - 1
            GldRowCoord(nJ) = GldRowCoord(nJ - 1) + dYStep
        Next nJ

        dCoeffY = dHeight / (GldRowCoord(GlnRowCount - 1) - GldRowCoord(0))
        dCoeffX = dWidth / (GldColumnCoord(GlnColumnCount - 1) - GldColumnCoord(0))


        ' Create the grid object
        On Error GoTo MetkaErrorContourCreateGrid

        nRC = DemoContourSetGrid(GlnColumnCount, GlnRowCount, _
                             Marshal.UnsafeAddrOfPinnedArrayElement(GldColumnCoord, 0), _
                             Marshal.UnsafeAddrOfPinnedArrayElement(GldRowCoord, 0), _
                             Marshal.UnsafeAddrOfPinnedArrayElement(GlardV, 0))

        If (nRC = CONTOUR_RC_ERROR Or nRC = CONTOUR_RC_NO_MEMORY) Then
            MsgBox("Object Contour can't create a grid")
            Exit Sub
        End If
        If (nRC > CONTOUR_RC_ERROR) Then
            Debug.Print("Count of grid points is " & Trim(Str(nRC)))
        End If

        '        Dim ptr As IntPtr = Marshal.UnsafeAddrOfPinnedArrayElement(dMin, 0)



        ' Get the min and max value of grid
        nRC = DemoContourGridGetMinMax(dMin, dMax)

        ' Set contour values array ( 9 values )
        d = dMax - dMin
        GdaContourValues(0) = dMin + d * 0.1
        GdaContourValues(1) = dMin + d * 0.2
        GdaContourValues(2) = dMin + d * 0.3
        GdaContourValues(3) = dMin + d * 0.4
        GdaContourValues(4) = dMin + d * 0.5
        GdaContourValues(5) = dMin + d * 0.6
        GdaContourValues(6) = dMin + d * 0.7
        GdaContourValues(7) = dMin + d * 0.8
        GdaContourValues(8) = dMin + d * 0.9
        nCount = 9
        ' Calculate 9 contours
        nRC = DemoContourCalculateIsolines(nCount, Marshal.UnsafeAddrOfPinnedArrayElement(GdaContourValues, 0))

        Exit Sub

MetkaNoFile:
        MsgBox("File " & sFile & " is missing")
        fs.Close()
        Exit Sub

MetkaErrorContourCreateGrid:
        MsgBox("Function ContourCreate is missing")
        Exit Sub
    End Sub



    Sub DrawContours()
        Dim dWidth As Double
        Dim dHeight As Double
        Dim longWidth As Integer
        Dim longHeight As Integer
        Dim sFont As String
        Dim lLeft As Integer
        Dim lRight As Integer
        Dim lTop As Integer
        Dim lBottom As Integer

        Dim nCount As Integer
        Dim nRC As Integer
        Dim nLines As Integer
        Dim nI As Integer
        Dim nJ As Integer

        If GlnRowCount > 50 Or GlnColumnCount > 50 Then
            Exit Sub
        End If

        Dim Mygraphics As Graphics
        Mygraphics = Form1.PictureBox1.CreateGraphics()
        Mygraphics.Clear(Color.White)
        dWidth = Form1.PictureBox1.Width
        dHeight = Form1.PictureBox1.Height

        ' Add the axis. The return code is axe index or -1 if fault
        lBottom = DemoContourAxisAdd("bottom")
        lTop = DemoContourAxisAdd("top")
        lLeft = DemoContourAxisAdd("left")
        lRight = DemoContourAxisAdd("right")

        ' Change font height. The default is 18
        Call DemoContourAxisSetFontHeight(lBottom, 10)
        Call DemoContourAxisSetFontHeight(lTop, 10)
        Call DemoContourAxisSetFontHeight(lLeft, 10)
        Call DemoContourAxisSetFontHeight(lRight, 10)

        ' Set the legends
        Call DemoContourAxisSetTitle(lBottom, "X, m")
        Call DemoContourAxisSetTitle(lLeft, "Y, m")
        Call DemoContourAxisSetTitle(lTop, "Top")


        ' Get count of groups of contour
        nCount = DemoContourIsolinesCount()

        ' Set HDC for canvas
        nRC = DemoContourCanvasSetHDC(Mygraphics.GetHdc())

        ' Set off the XY rate (1 - on, 0 - off)

        Dim nXYRate As Integer
        nXYRate = 0
        Call DemoContourCanvasSetXYRate(nXYRate)

        ' Set canvas size in pixels
        longWidth = Form1.PictureBox1.Width
        longHeight = Form1.PictureBox1.Height
        nRC = DemoContourCanvasSetSize(longWidth, longHeight)

        ' Set view rectangle for canvas
        ' The function set pixel-coordinate system
        nRC = DemoContourCanvasSetLimits(GldColumnCoord(0), GldRowCoord(0), _
            GldColumnCoord(GlnColumnCount - 1), GldRowCoord(GlnRowCount - 1))

        sFont = "Times New Roman" ' Use TRUE TYPE fonts ONLY
        ' Default font is Arial
        nRC = DemoContourCanvasSetFontFaceName(sFont)
        ' Default font height is 20
        nRC = DemoContourCanvasSetFontHeight(15)

        Call DemoContourAxisDraw()

        For nI = 0 To nCount - 1
            ' Set label value
            nRC = DemoContourCanvasSetLabelValue(GdaContourValues(nI))

            ' Get count of lines in nI group (for value aContourValues(nI))
            nLines = DemoContourLinesCount(nI)
            For nJ = 0 To nLines - 1
                ' Get count of vertices of nJ line for nI group
                GlnPoints = DemoContourPointsCount(nI, nJ)
                nRC = DemoContourGetIsolinePoints(nI, nJ, Marshal.UnsafeAddrOfPinnedArrayElement(GldLineCoordX, 0), _
                                              Marshal.UnsafeAddrOfPinnedArrayElement(GldLineCoordY, 0))
                ' Draw contour line
                Call DemoContourCanvasDrawContour(GlnPoints, Marshal.UnsafeAddrOfPinnedArrayElement(GldLineCoordX, 0), _
                    Marshal.UnsafeAddrOfPinnedArrayElement(GldLineCoordY, 0))
            Next nJ
        Next nI
        Exit Sub
    End Sub

End Module













































